package hstar.creole.parser

/**
 * Developed with pleasure :)<br>
 * User: HoD<br>
 * Date: 02.10.2010<br>
 * Time: 20:32:39<br>
 */

class ParsingContext(val currentIncompleteElement: IntermediateSyntaxNode, cursor: CursorView, val source: String) {
  def remainingText = {
    if (cursor.currentIndex < source.length) {
      source.substring(cursor.currentIndex)
    } else {
      ""
    }
  }

  private def toValidIndex(index:Int, string:String) = {
    if (index == -1) {
      string.length
    } else {
      index      
    }
  } 
  
  /**
   * @return the current line & the relative index of the cursor on this substring 
   */
  def currentLineAndRelativeCursorIndex = {
    val beginAt = source.lastIndexOf(SyntaxRules.lineBreak, cursor.currentIndex - 1) max 0
    val endAt = toValidIndex(source.indexOf(SyntaxRules.lineBreak, cursor.currentIndex),source)
    source.substring(beginAt, endAt) -> (cursor.currentIndex - beginAt) 
  }
  
  def remainingLine = {
    remainingText.takeWhile(_ != SyntaxRules.lineBreakChar)
  }
  
  def nextLine = {
    val operateOn = remainingText
    val nextLineBreak = operateOn.indexOf(SyntaxRules.lineBreakChar)
    if (nextLineBreak == -1) {
      None
    } else {
      val endAt = toValidIndex(operateOn.indexOf(SyntaxRules.lineBreak, nextLineBreak + 1), operateOn)
      val result = operateOn.substring(nextLineBreak + 1, endAt)
      Some(result)
    }
  }

  def allParents = {
    currentIncompleteElement.selfAndAllParents
  }
  
  def withNewSource(newSource:String) = {
    new ParsingContext(currentIncompleteElement, new Cursor(newSource.length).view, newSource)
  }
}