package hstar.creole.transformation

import hstar.creole.syntaxtree.Element

/**
 * Developed with pleasure :)<br>
 * User: HoD<br>
 * Date: 28.09.2010<br>
 * Time: 21:31:36<br>
 */

trait Transformer[T] {
  def transformElement(e:Element):Node[T]
}

object Transformer {
  private def transform[T](root:Element, transformer:Transformer[T]):Node[T] = {
    transform(root, transformer, None)  
  }
  
  private def transform[T](root:Element, transformer:Transformer[T], parent:Option[Node[T]]):Node[T] = {
    val element = {
      def transform = transformer.transformElement(root)
      parent.map(transform.withParent).getOrElse(transform) 
      
    }
    val transformedChildren = root.children.map(transform(_, transformer, parent))
    element.withChildren(transformedChildren)
  }
}